;;;; File: resource-demo-tests.lsp
;;; SCCS Version: %W%
;;; Contains: Release tests for automatic testing.
;;; Author: Jeff Dalton <J.Dalton@ed.ac.uk>
;;; Created: July 1994
;;; Updated: Thu Nov 17 18:12:57 1994 by Jeff Dalton
;;; Release Version: %Y%
;;; Copyright: (c) 1994, AIAI, University of Edinburgh
;;; This material may be reproduced by or for the U.S. Government pursuant
;;; to the copyright license under the clause at DFARS 252.227-7032
;;; (June 1975) -- Rights in Technical Data and Computer Software (Foreign).

;;; N.B. Not loaded automatically as part of the auto-tester system.

(in-package :autotester)

(export '(run-resource-demo-test-sequence))

(setq *resource-demo-test-sequence*

  (list

    ;; Pacifica-3
    (make-plan-test
      :domain     "pacifica-3"
      :task       "task_operation_columbus"
      :replans    2
      :exhaustive nil)

    (make-plan-test
      :domain     "pacifica-3"
      :task       "task_operation_columbus_mixed_transports"
      :replans    2
      :exhaustive nil)


    (make-plan-test
      :domain     "pacifica-3"
      :task       "task_operation_columbus_ground_transports_only"
      :replans    2
      :exhaustive nil)

    (make-plan-test
      :domain     "pacifica-3"
      :task       "task_operation_columbus_helicopters_only"
      :replans    2
      :exhaustive nil)

    ))

;;; Run-resource-demo-test-sequence runs all cases we want to check
;;; before a release.

(defun run-resource-demo-test-sequence (&rest keyword-args)
  (apply #'run-test-sequence *resource-demo-test-sequence*
	 :sanity-check-only t
	 keyword-args))

;;; End
