;;;; File: schemadef.lsp
;;;; SCCS Version: %W%
;;;; Contains: The TF schema definition.
;;;; Author: Richard Kirby (rbk)
;;;; Created: Tue Oct 30 11:00:40 1990
;;;; Updated: Thu Aug 11 17:08:21 1994 by Jeff Dalton
;;;; Release Version: %Y%
;;;; Copyright: (c) 1992, AIAI, University of Edinburgh
;;;; This material may be reproduced by or for the U.S. Government pursuant
;;;; to the copyright license under the clause at DFARS 252.227-7032
;;;; (June 1975) -- Rights in Technical Data and Computer Software (Foreign).

(in-package :oplan)

(import-struct 'schema-defs:domain)
(import-struct 'schema-defs:schema)

(import-struct 'schema-defs:effect)
(import-struct 'schema-defs:con)

(defmacro effect-at-node-end (e) `(effect-point ,e))
(defmacro con-at-node-end   (c) `(con-point ,c))

(import-struct 'schema-defs:node)

(defmacro node-num (n) `(node-number ,n))

;; Time windows in the schema record have the following structure:
;; (<node-end | :ABST0> <node-end> (<min> <max> <pref>))

(defun time-window-start (time-window) (first time-window))

(defsetf time-window-start (time-window) (new-start)
  `(setf (first ,time-window) ,new-start))

(defun time-window-end (time-window) (second time-window))

(defun time-window-min (time-window) (first (third time-window)))

(defun time-window-max (time-window) (second (third time-window)))

(defun time-window-pref (time-window) (third (third time-window)))

(defun compute-memo (pattern value)
  (declare (ignore pattern))
  value)

#|
;;;; Pretty printing functions.
(defun pretty-print-schema-def (stream schema)
  )

(defun pretty-print-domain-def (stream domain)
  )

(eval-when (load eval)
  (when (find-package :MON)
    (mon-add-user-def-print-fn 'domain #'pretty-print-domain-def)
    (mon-add-user-def-print-fn 'schema #'pretty-print-schema-def)))
|#

;;;; ---------------------------- Change History ----------------------------
;;;; (Initials) (Date of change)           (Comment)
