;;;; File: com-pack.lsp
;;; SCCS Version: %W%
;;; Contains: Package definition for the TF compiler implementation
;;; Author: Jeff Dalton <J.Dalton@ed.ac.uk>
;;; Created: March 1992
;;; Updated: Tue Sep 27 15:12:04 1994 by Jeff Dalton
;;; Release Version: %Y%
;;; Copyright: (c) 1992, 1993, 1994 AIAI, University of Edinburgh
;;; This material may be reproduced by or for the U.S. Government pursuant
;;; to the copyright license under the clause at DFARS 252.227-7032
;;; (June 1975) -- Rights in Technical Data and Computer Software (Foreign).


;;; N.B. must :use the package that defines the symbols in the
;;; TF language.

(in-package :user)

(defpackage "TF-COMPILER"
  (:use #+:cltl2 "COMMON-LISP"
	#-:cltl2 "LISP"
		 "TF-LANGUAGE"
		 "SCHEMA-DEFS"
		 "PARSER-KIT"
		 "MONITORS"
		 "DEVELOPERLIB"
		 "UTIL")	
  (:import-from "ACT" "ACTORSYM"
		      "ACTORP"
		      "QUESTION-READER"
		      "GIVEN"
		      "ACTFN"
		      "ACTARGS"
		      "MAKE-GIVEN-ACTOR"
		      "MAKE-FUNCTION-ACTOR"
		      "ACTOR-RENAME")
  (:shadowing-import-from "OPLAN"	;/\/ shouldn't be necessary
			  "NODES")
  (:export "COMPILE-TF-STREAM"
	   "COMPILE-FROM-TF-FILE"
	   "COMPILE-FROM-TF-STRING"
	   "RUN-AS-TFC"
	   "TFC"
	   "ACTION-LEVEL"
	   "EFFECT-LEVEL"))

;;; End
