;;;; File: KS-COMPUTE.lsp
;;; SCCS Version: %W%
;;; Contains: The COMPUTE KS
;;; Author: Jeff Dalton <J.Dalton@ed.ac.uk>
;;; Created: July 1994
;;; Updated: Thu Aug 11 17:05:09 1994 by Jeff Dalton
;;; Release Version: %Y%
;;; Copyright: (c) 1994, AIAI, University of Edinburgh
;;; This material may be reproduced by or for the U.S. Government pursuant
;;; to the copyright license under the clause at DFARS 252.227-7032
;;; (June 1975) -- Rights in Technical Data and Computer Software (Foreign).

(in-package :knowledge-source)

(defun KS-COMPUTE (ag)
  (destructuring-bind (cond) (cdr (ag-body ag))
    (let ((p (con-pattern cond))
	  (v (con-value cond)))
      ;; The trigger should have assured that all PSVs in p are bound,
      ;; but v may contain some unbound ones.
      (unless (db-request :EVALUATE-COMPUTE p v) 
	(post-agenda `(:POISON-STATE :CANT-COMPUTE ,p = ,v))))))

;;; ---------------------------- Change History ----------------------------
;;; (Who)   (When) 		     (What)
;;;
