;;;; File: KS-EXECUTION-SUCCESS.lsp
;;; SCCS Version: %W%
;;; Contains: KS that deal with successful execution of an end of an action
;;; Author: Jeff Dalton <J.Dalton@ed.ac.uk>
;;; Created: Sat 18 February 1995
;;; Updated: Tue Jun  6 18:30:12 1995 by Jeff Dalton
;;; Release Version: %Y%
;;; Copyright: (c) 1995, AIAI, University of Edinburgh
;;; This material may be reproduced by or for the U.S. Government pursuant
;;; to the copyright license under the clause at DFARS 252.227-7032
;;; (June 1975) -- Rights in Technical Data and Computer Software (Foreign).

(in-package :knowledge-source)

(defun KS-EXECUTION-SUCCESS (event)
  (destructuring-bind (when etag pattern) (cdr (ag-body event))
    (declare (ignore when pattern))

    ;(MONITOR :KP-1 (:ONE-LINER "Successfully executed ~A ~W" etag pattern))

    ;; Mark the node-end has having been executed.
    (db-call 'set-etag-exec-status etag :finished)

    ;; Continue execution.
    (tell-exec-to-execute-next-fringe etag)))

;;; ---------------------------- Change History ----------------------------
;;; (Who)   (When) 		     (What)
;;;
