

/* Begin for cmpinclude */
#ifndef __GNUC__
#define HAVE_ALLOCA
#include <alloca.h>
#endif
 /* If can mprotect pages and so selective gc will work */
#define SGC  

/* End for cmpinclude */
/*
(c) Copyright Taiichi Yuasa and Masami Hagiya, 1984.  All rights reserved.
Copying of this file is authorized to users who have executed the true and
proper "License Agreement for Kyoto Common LISP" with SIGLISP.
*/
#include <stdio.h>
#include <setjmp.h>
#include <varargs.h>
#define	TRUE	1
#define	FALSE	0
#ifdef SGC
#define FIRSTWORD     short t; char s,m
#define SGC_TOUCH(x) x->d.m=0
#else
#define FIRSTWORD     short t; short m
#define SGC_TOUCH(x)
#endif  
#define STSET(type,x,i,val)  do{SGC_TOUCH(x);STREF(type,x,i) = (val);} while(0)
#ifndef VOL
#define VOL
#endif
#ifndef COM_LENG
#define COM_LENG 
#endif
#ifndef CHAR_SIZE
#define CHAR_SIZE        8     
#endif
typedef int bool;
typedef int fixnum;
typedef float shortfloat;
typedef double longfloat;
typedef  unsigned short fatchar;
#define SIGNED_CHAR(x) (((char ) -1) < (char )0 ? (char) x \
		  : (x >= (1<<(CHAR_SIZE-1)) ? \
		     x - (((int)(1<<(CHAR_SIZE-1))) << 1) \
		     : (char ) x))
typedef union lispunion *object;
typedef union int_object iobject;
union int_object {int i; object o;};

#define	OBJNULL	((object)NULL)
struct fixnum_struct {
		FIRSTWORD;
	fixnum	FIXVAL;
};
#define	fix(x)	(x)->FIX.FIXVAL
#define	SMALL_FIXNUM_LIMIT	1024
extern struct fixnum_struct small_fixnum_table[COM_LENG];
#define	small_fixnum(i)	(object)(small_fixnum_table+SMALL_FIXNUM_LIMIT+(i))

struct bignum {
			FIRSTWORD;
	long             *big_self;	/*  bignum body  */
	int		big_length;	/*  bignum length  */
};
#define MP(x) ((GEN)(x)->big.big_self)
struct shortfloat_struct {
			FIRSTWORD;
	shortfloat	SFVAL;
};
#define	sf(x)	(x)->SF.SFVAL
struct longfloat_struct {
			FIRSTWORD;
	longfloat	LFVAL;
};
#define	lf(x)	(x)->LF.LFVAL
struct character {
			FIRSTWORD;
	unsigned short	ch_code;
	unsigned char	ch_font;
	unsigned char	ch_bits;
};
struct character character_table1[256+128];
#define character_table (character_table1+128)
#define	code_char(c)	(object)(character_table+(c))
#define	char_code(x)	(x)->ch.ch_code
#define	char_font(x)	(x)->ch.ch_font
#define	char_bits(x)	(x)->ch.ch_bits
enum stype {
	stp_ordinary,
	stp_constant,
        stp_special
};
struct symbol {
		FIRSTWORD;
	object	s_dbind;
	int	(*s_sfdef)();
#define	s_fillp		st_fillp
#define	s_self		st_self
	int	s_fillp;
	char	*s_self;
	object	s_gfdef;
	object	s_plist;
	object	s_hpack;
	short	s_stype;
	short	s_mflag;
};
struct cons {
		FIRSTWORD;
	object	c_cdr;
	object	c_car;
};
struct array {
		FIRSTWORD;
	short	a_rank;
	short	a_adjustable;
	int	a_dim;
	int	*a_dims;
	object	*a_self;
	object	a_displaced;
	short	a_elttype;
	short	a_offset;
};



struct fat_string {			/*  vector header  */
		FIRSTWORD;
        unsigned fs_raw : 24;     /* tells if the things in leader are raw */
	unsigned char fs_leader_length;	 /* leader_Length  */
	int	fs_dim;		/*  dimension  */
	int	fs_fillp;	/*  fill pointer  */
				/*  For simple vectors,  */
				/*  fs_fillp is equal to fs_dim.  */
	fatchar 	*fs_self;	/*  pointer to the vector Note the leader starts at (int *) *fs_self - fs_leader_length */
};


struct vector {
		FIRSTWORD;
	short	v_hasfillp;
	short	v_adjustable;
	int	v_dim;
	int	v_fillp;
	object	*v_self;
	object	v_displaced;
	short	v_elttype;
	short	v_offset;
};
struct string {
		FIRSTWORD;
	short	st_hasfillp;
	short	st_adjustable;
	int	st_dim;
	int	st_fillp;
	char	*st_self;
	object	st_displaced;
};
struct ustring {
		FIRSTWORD;
	short	ust_hasfillp;
	short	ust_adjustable;
	int	ust_dim;
	int	ust_fillp;
	unsigned char
		*ust_self;
	object	ust_displaced;
};
#define USHORT(x,i) (((unsigned short *)(x)->ust.ust_self)[i])

struct bitvector {
		FIRSTWORD;
	short	bv_hasfillp;
	short	bv_adjustable;
	int	bv_dim;
	int	bv_fillp;
	char	*bv_self;
	object	bv_displaced;
	short	bv_elttype;
	short	bv_offset;
};
struct fixarray {
		FIRSTWORD;
	short	fixa_rank;
	short	fixa_adjustable;
	int	fixa_dim;
	int	*fixa_dims;
	fixnum	*fixa_self;
	object	fixa_displaced;
	short	fixa_elttype;
	short	fixa_offset;
};
struct sfarray {
		FIRSTWORD;
	short	sfa_rank;
	short	sfa_adjustable;
	int	sfa_dim;
	int	*sfa_dims;
	shortfloat
		*sfa_self;
	object	sfa_displaced;
	short	sfa_elttype;
	short	sfa_offset;
};
struct lfarray {
		FIRSTWORD;
	short	lfa_rank;
	short	lfa_adjustable;
	int	lfa_dim;
	int	*lfa_dims;
	longfloat
		*lfa_self;
	object	lfa_displaced;
	short	lfa_elttype;
	short	lfa_offset;
};

struct structure {		/*  structure header  */
		FIRSTWORD;
	object	str_def;	/*  structure definition (a structure)  */
	object	*str_self;	/*  structure self  */
};

#define STREF(type,x,i) (*((type *)(((char *)((x)->str.str_self))+(i))))

struct cfun {
		FIRSTWORD;
	object	cf_name;
	int	(*cf_self)();
	object	cf_data;
};

  struct dclosure {		/*  compiled closure header  */
		FIRSTWORD;
	int	(*dc_self)();	/*  entry address  */
	object	*dc_env;	/*  environment  */
};

  struct cclosure {
		FIRSTWORD;

	object	cc_name;
	int	(*cc_self)();
	object	cc_env;
	object	cc_data;
	object	*cc_turbo;
};

struct sfun {
	FIRSTWORD;
	object	sfn_name;
	int	(*sfn_self)();
	object	sfn_data;
	int sfn_argd;

	      };
struct vfun {
		FIRSTWORD; 
	object	vfn_name;
	int	(*vfn_self)();
	object	vfn_data;
	unsigned short vfn_minargs;
	unsigned short vfn_maxargs;
	      };

struct dummy {
		FIRSTWORD;
};
struct stream {
		FIRSTWORD;
	FILE	*sm_fp;		/*  file pointer  */
	object	sm_object0;	/*  some object  */
	object	sm_object1;	/*  some object */
	int	sm_int0;	/*  some int  */
	int	sm_int1;	/*  some int  */
	char  	*sm_buffer;     /*  ptr to BUFSIZE block of storage */
	short	sm_mode;	/*  stream mode  */
				/*  of enum smmode  */
};
union lispunion {
	struct fixnum_struct
			FIX;
	struct shortfloat_struct
			SF;
	struct stream sm;
	struct longfloat_struct
			LF;
	struct character
			ch;
	struct symbol	s;
	struct cons	c;
	struct array	a;
	struct vector	v;
	struct string	st;
	struct ustring	ust;
	struct bignum   big;
	struct bitvector
			bv;
	struct structure
			str;
	struct cfun	cf;
	struct cclosure	cc;
	struct sfun     sfn;
	struct vfun     vfn;
	struct dummy	d;
        struct fat_string fs;
        struct dclosure dc;
	struct fixarray	fixa;
	struct sfarray	sfa;
	struct lfarray	lfa;
};
enum type {
	t_cons,
	t_start = 0 , /* t_cons, */
	t_fixnum,
	t_bignum,
	t_ratio,
	t_shortfloat,
	t_longfloat,
	t_complex,
	t_character,
	t_symbol,
	t_package,
	t_hashtable,
	t_array,
	t_vector,
	t_string,
	t_bitvector,
	t_structure,
	t_stream,
	t_random,
	t_readtable,
	t_pathname,
	t_cfun,
	t_cclosure,
	t_sfun,
        t_gfun,
	t_vfun,
	t_cfdata,
	t_spice,
	t_fat_string,
        t_dclosure,
	t_end,
	t_contiguous,
	t_relocatable,
	t_other
};
#define	type_of(obje)	((enum type)(((object)(obje))->d.t))
#define	endp(obje)	endp1(obje)
extern object value_stack[COM_LENG];
#define	vs_org		value_stack
object *vs_limit;
object *vs_base;
object *vs_top;
#define	vs_push(obje)	(*vs_top++ = (obje))
#define	vs_pop		(*--vs_top)
#define	vs_head		vs_top[-1]
#define	vs_mark		object *old_vs_top = vs_top
#define	vs_reset	vs_top = old_vs_top
#define	vs_check	if (vs_top >= vs_limit)  \
				vs_overflow();
#define	vs_check_push(obje)  \
			(vs_top >= vs_limit ?  \
			 (object)vs_overflow() : (*vs_top++ = (obje)))
#define	check_arg(n)  \
			if (vs_top - vs_base != (n))  \
				check_arg_failed(n)
#define	MMcheck_arg(n)  \
			if (vs_top - vs_base < (n))  \
				too_few_arguments();  \
			else if (vs_top - vs_base > (n))  \
				too_many_arguments()
#define vs_reserve(x)	if(vs_base+(x) >= vs_limit)  \
				vs_overflow();
struct bds_bd {
	object	bds_sym;
	object	bds_val;
};
extern struct bds_bd bind_stack[COM_LENG];
typedef struct bds_bd *bds_ptr;
bds_ptr bds_org;
bds_ptr bds_limit;
bds_ptr bds_top;
#define	bds_check  \
	if (bds_top >= bds_limit)  \
		bds_overflow()
#define	bds_bind(sym, val)  \
	((++bds_top)->bds_sym = (sym),  \
	bds_top->bds_val = (sym)->s.s_dbind,  \
	(sym)->s.s_dbind = (val))
#define	bds_unwind1  \
	((bds_top->bds_sym)->s.s_dbind = bds_top->bds_val, --bds_top)
typedef struct invocation_history {
	object	ihs_function;
	object	*ihs_base;
} *ihs_ptr;
extern struct invocation_history ihs_stack[COM_LENG];
ihs_ptr ihs_org;
ihs_ptr ihs_limit;
ihs_ptr ihs_top;
#define	ihs_check  \
	if (ihs_top >= ihs_limit)  \
		ihs_overflow()
#define ihs_push(function)  \
	(++ihs_top)->ihs_function = (function);  \
	ihs_top->ihs_base = vs_base
#define ihs_pop() 	(ihs_top--)
enum fr_class {
	FRS_CATCH,
	FRS_CATCHALL,
	FRS_PROTECT
};
struct frame {
	jmp_buf		frs_jmpbuf;
	object		*frs_lex;
	bds_ptr		frs_bds_top;
	enum fr_class	frs_class;
	object		frs_val;
	ihs_ptr		frs_ihs;
};
typedef struct frame *frame_ptr;
#define	alloc_frame_id()	alloc_object(t_spice)
extern struct frame frame_stack[COM_LENG];

frame_ptr frs_org;
frame_ptr frs_limit;
frame_ptr frs_top;
#define frs_push(class, val)  \
	if (++frs_top >= frs_limit)  \
		frs_overflow();  \
	frs_top->frs_lex = lex_env;\
	frs_top->frs_bds_top = bds_top;  \
	frs_top->frs_class = (class);  \
	frs_top->frs_val = (val);  \
	frs_top->frs_ihs = ihs_top;  \
        setjmp(frs_top->frs_jmpbuf)
#define frs_pop()	frs_top--
bool nlj_active;
frame_ptr nlj_fr;
object nlj_tag;
object *lex_env;
object caar();
object cadr();
object cdar();
object cddr();
object caaar();
object caadr();
object cadar();
object caddr();
object cdaar();
object cdadr();
object cddar();
object cdddr();
object caaaar();
object caaadr();
object caadar();
object caaddr();
object cadaar();
object cadadr();
object caddar();
object cadddr();
object cdaaar();
object cdaadr();
object cdadar();
object cdaddr();
object cddaar();
object cddadr();
object cdddar();
object cddddr();
#define MMcons(a,d)	make_cons((a),(d))
#define MMcar(x)	(x)->c.c_car
#define MMcdr(x)	(x)->c.c_cdr
#define CMPcar(x)	(x)->c.c_car
#define CMPcdr(x)	(x)->c.c_cdr
#define CMPcaar(x)	(x)->c.c_car->c.c_car
#define CMPcadr(x)	(x)->c.c_cdr->c.c_car
#define CMPcdar(x)	(x)->c.c_car->c.c_cdr
#define CMPcddr(x)	(x)->c.c_cdr->c.c_cdr
#define CMPcaaar(x)	(x)->c.c_car->c.c_car->c.c_car
#define CMPcaadr(x)	(x)->c.c_cdr->c.c_car->c.c_car
#define CMPcadar(x)	(x)->c.c_car->c.c_cdr->c.c_car
#define CMPcaddr(x)	(x)->c.c_cdr->c.c_cdr->c.c_car
#define CMPcdaar(x)	(x)->c.c_car->c.c_car->c.c_cdr
#define CMPcdadr(x)	(x)->c.c_cdr->c.c_car->c.c_cdr
#define CMPcddar(x)	(x)->c.c_car->c.c_cdr->c.c_cdr
#define CMPcdddr(x)	(x)->c.c_cdr->c.c_cdr->c.c_cdr
#define CMPcaaaar(x)	(x)->c.c_car->c.c_car->c.c_car->c.c_car
#define CMPcaaadr(x)	(x)->c.c_cdr->c.c_car->c.c_car->c.c_car
#define CMPcaadar(x)	(x)->c.c_car->c.c_cdr->c.c_car->c.c_car
#define CMPcaaddr(x)	(x)->c.c_cdr->c.c_cdr->c.c_car->c.c_car
#define CMPcadaar(x)	(x)->c.c_car->c.c_car->c.c_cdr->c.c_car
#define CMPcadadr(x)	(x)->c.c_cdr->c.c_car->c.c_cdr->c.c_car
#define CMPcaddar(x)	(x)->c.c_car->c.c_cdr->c.c_cdr->c.c_car
#define CMPcadddr(x)	(x)->c.c_cdr->c.c_cdr->c.c_cdr->c.c_car
#define CMPcdaaar(x)	(x)->c.c_car->c.c_car->c.c_car->c.c_cdr
#define CMPcdaadr(x)	(x)->c.c_cdr->c.c_car->c.c_car->c.c_cdr
#define CMPcdadar(x)	(x)->c.c_car->c.c_cdr->c.c_car->c.c_cdr
#define CMPcdaddr(x)	(x)->c.c_cdr->c.c_cdr->c.c_car->c.c_cdr
#define CMPcddaar(x)	(x)->c.c_car->c.c_car->c.c_cdr->c.c_cdr
#define CMPcddadr(x)	(x)->c.c_cdr->c.c_car->c.c_cdr->c.c_cdr
#define CMPcdddar(x)	(x)->c.c_car->c.c_cdr->c.c_cdr->c.c_cdr
#define CMPcddddr(x)	(x)->c.c_cdr->c.c_cdr->c.c_cdr->c.c_cdr
#define CMPfuncall	funcall
#define	cclosure_call	funcall
object simple_lispcall();
object simple_lispcall_no_event();
object simple_symlispcall();
object simple_symlispcall_no_event();
object CMPtemp;
object CMPtemp1;
object CMPtemp2;
object CMPtemp3;
#define	Cnil	((object)&Cnil_body)
#define	Ct	((object)&Ct_body)
struct symbol Cnil_body, Ct_body;
object MF();
object MFnew();
object MM();
object Scons;
object siSfunction_documentation;
object siSvariable_documentation;
object siSpretty_print_format;
object Slist;
object keyword_package;
object alloc_object();
object car();
object cdr();
object list();
object listA();
object coerce_to_string();
object elt();
object elt_set();
frame_ptr frs_sch();
frame_ptr frs_sch_catch();
object make_cclosure();
object make_cclosure_new();
object nth();
object nthcdr();
object make_cons();
object append();
object nconc();
object reverse();
object nreverse();
object number_expt();
object number_minus();
object number_negate();
object number_plus();
object number_times();
object one_minus();
object one_plus();
object get();
object getf();
object putprop();
object sputprop();
object remprop();
object string_to_object();
object symbol_function();
object symbol_value();
object make_fixnum();
object make_shortfloat();
object make_longfloat();
object structure_ref();
object structure_set();
object princ();
object prin1();
object print();
object terpri();
object aref();
object aset();
object aref1();
object aset1();
void call_or_link();
void call_or_link_closure();
object call_proc();
object call_proc0();
object call_proc1();
object call_proc2();
object ifuncall();   
object ifuncall1();
object ifuncall2();
object symbol_name();
char object_to_char();
int object_to_int();
float object_to_float();
double object_to_double();
char *object_to_string();
int FIXtemp;
#define	CMPmake_fixnum(x) \
((((FIXtemp=(x))+1024)&-2048)==0?small_fixnum(FIXtemp):make_fixnum(FIXtemp))
#define Creturn(v) return((vs_top=vs,(v)))
#define Cexit return((vs_top=vs,0))
double sin(), cos(), tan();
object read_byte1(),read_char1();

#define fs_leader(ar,i) (((object *)((ar)->fs.fs_self))[-(i+1)])
#define RPAREN )
object make_list();
#ifdef HAVE_ALLOCA
#ifndef alloca
char *alloca();
#endif
char *alloca_val;
#define ALLOCA_CONS(n) (alloca_val=alloca((n)*sizeof(struct cons))) 
#define ON_STACK_CONS(x,y) (alloca_val=alloca(sizeof(struct cons)), on_stack_cons(x,y)) 
#define ON_STACK_LIST on_stack_list
#define ON_STACK_LIST_VECTOR on_stack_list_vector
#define ON_STACK_MAKE_LIST on_stack_make_list
object on_stack_cons();
object on_stack_list();
object on_stack_list_vector();
object on_stack_make_list();
#else
#define ALLOCA_CONS(n) 0
#define ON_STACK_CONS(x,y) MMcons(x,y)
#define ON_STACK_LIST list
#define ON_STACK_LIST_VECTOR list_vector
#define ON_STACK_MAKE_LIST make_list
#endif


struct call_data { object fun;
		   int argd;};
struct call_data fcall;
object  fcalln();
object list_vector();
object MVloc[10];
#define VARG(min,max) ((min) | (max << 8))
#define  VFUN_NARGS fcall.argd
extern object Cstd_key_defaults[];
int vfun_wrong_number_of_args();
int eql(),equal(),eq();
object sublis1();
object LVformat(),LVerror();
#define EQ(x,y) ((x)==(y))



/* #include "../h/genpari.h"*/
typedef  long *GEN;
GEN addii(),mulii(),mulsi(),powerii(),shifti(),stoi(),dvmdii(),subii();
int cmpii();
#define signe(x)          (((GEN)(x))[1]>>24)
#define lg(x)             (((GEN)(x))[0]&0xffff)
#define setlg(x,s)        (((GEN)(x))[0]=(((GEN)(x))[0]&0xffff0000)+s)
#define lgef(x)           (((GEN)(x))[1]&0xffff)
#define setlgef(x,s)      (((GEN)(x))[1]=(((GEN)(x))[1]&0xffff0000)+s)

int in_saved_avma ;
#define ulong unsigned long
/* #define DEBUG_AVMA */

#ifdef DEBUG_AVMA
#define save_avma long lvma = (in_saved_avma = 1, avma)
#define restore_avma avma = (in_saved_avma = 0, lvma)
#else
#define save_avma long lvma = avma
#define restore_avma avma = lvma
#endif
unsigned long avma;
GEN gzero;
GEN icopy_x;

object make_integer();
  /* copy x to y, increasing space by factor of 2  */


GEN otoi();
/*
object integ_temp;
#define otoi(x) (integ_temp = (x) , (type_of(integ_temp) == t_bignum \
   ? MP(integ_temp) :stoi(fix(integ_temp))))
*/

#define ISETQ_FIX(a,b,c) SETQ_II(a,b,stoi(c))

#ifdef HAVE_ALLOCA
#define SETQ_II(var,alloc,val) \
  do{GEN _xx =(val) ; \
  int _n = replace_copy1(_xx,var); \
  if(_n) var = replace_copy2(_xx,alloca(_n));}while(0)

#define SETQ_IO(var,alloc,val) {object _xx =(val) ; \
			      int _n = obj_replace_copy1(_xx,var); \
			    if(_n) var = obj_replace_copy2(_xx,alloca(_n));}
#define IDECL(a,b,c) ulong b[4];a =(b[0]=0x1010000 +4,b) ; object c
#else
GEN setq_io(),setq_ii();
#define SETQ_IO(x,alloc,val)   (x)=setq_io(x,&alloc,val)
#define SETQ_II(x,alloc,val)   (x)=setq_ii(x,&alloc,val)
#define IDECL(a,b,c) ulong b[4];a =(b[0]=0x1010000 +4,b);object c
#endif

object cmod(), cplus(), cdifference(), ctimes();

#ifdef __GNUC__
#define alloca __builtin_alloca
#endif



#include "xfork.h"
init_code(){do_init(VV);}
/*	function definition for C-STRING	*/

static L1()
{register object *base=vs_base;
	register object *sup=base+VM1; VC1
	vs_check;
	{object V1;
	V1=(base[0]);
	vs_top=sup;
TTL:;
	base[1]= VV[0];
	base[2]= coerce_to_string((V1));
	base[3]= make_cons(code_char((0)),Cnil);
	vs_top=(vs_base=base+1)+3;
	(void) (*Lnk25)();
	return;
	}
}
	extern char *sys_errlist[];
	extern int errno, sys_nerr;
	Zerror(default_msg)
	char *default_msg;
	{
	    if (errno >= sys_nerr)
	        FEerror(default_msg, 0);
	    else
	        FEerror(sys_errlist[errno], 0);
	}
	object zfork()
	{
	    int pid;
	    check_arg(0);
	    pid = fork();
	    if (pid == -1)
		Zerror("Fork failed.");
	    else if (pid == 0)
		return (Cnil);
	    else
		return (make_fixnum(pid));
	}
/*	function definition for FORK	*/

static L2()
{	object *old_base=vs_base;
	object x;
	x=
	zfork();
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=x;
}
	void z_exit(n)
	object n;
	{
	    check_arg(1);
	    _exit(fix(n));
	}
/*	function definition for EXIT-CHILD	*/

static L3()
{	object *old_base=vs_base;
	z_exit(
	vs_base[0]);
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=Cnil;
}
	object zwait()
	{
	    int status = -1, pid;
	    object result;
	    extern int errno;
	    check_arg(0);
	    pid = wait(&status);
	    result = make_cons(Cnil, Cnil);
	    vs_push(result);
	    result->c.c_car = make_fixnum(pid);
	    result->c.c_cdr = make_fixnum(pid != -1 ? status : errno);
	    return(vs_pop);
	}
/*	function definition for WAIT	*/

static L4()
{	object *old_base=vs_base;
	object x;
	x=
	zwait();
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=x;
}
#	include <sys/wait.h>
	object zwaitpid_no_hang(zpid)
	object zpid;
	{
	    int status = -1, pid;
	    object result;
	    extern int errno;

	    check_arg(1);
	    pid = waitpid(fix(zpid), &status, WNOHANG);
	    result = make_cons(Cnil, Cnil);
	    vs_push(result);
	    result->c.c_car = make_fixnum(pid);
	    result->c.c_cdr = make_fixnum(pid != -1 ? status : errno);
	    return(vs_pop);
	}
/*	function definition for WAITPID-NO-HANG	*/

static L5()
{	object *old_base=vs_base;
	object x;
	x=
	zwaitpid_no_hang(
	vs_base[0]);
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=x;
}
	object zpipe()
	{
	    int fildes[2];
	    object result;
	    check_arg(0);
	    if (pipe(fildes) == -1)
	        Zerror("Pipe failed.");
	    result = make_cons(Cnil, Cnil);
	    vs_push(result);
	    result->c.c_car = make_fixnum(fildes[0]); /* from */
	    result->c.c_cdr = make_fixnum(fildes[1]); /* to   */
	    return(vs_pop);
	}
/*	function definition for PIPE	*/

static L6()
{	object *old_base=vs_base;
	object x;
	x=
	zpipe();
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=x;
}
	object zdup(fildes)
	object fildes;
	{
	    int result;
	    check_arg(1);
	    result = dup(fix(fildes));
	    if (result == -1) Zerror("Dup failed.");
	    return(make_fixnum(result));
	}
/*	function definition for DUP	*/

static L7()
{	object *old_base=vs_base;
	object x;
	x=
	zdup(
	vs_base[0]);
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=x;
}
	object zdup2 (fildes1, fildes2)
	object fildes1, fildes2;
	{
	    int fd1, fd2;
	    check_arg(2);
	    fd1 = fix(fildes1);
	    fd2 = fix(fildes2);
	    if (dup2(fd1, fd2) == -1)
	       Zerror("Dup2 failed.");
	    return(Cnil);
	}
/*	function definition for DUP2	*/

static L8()
{	object *old_base=vs_base;
	object x;
	x=
	zdup2(
	vs_base[0],
	vs_base[1]);
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=x;
}
typedef object Sobject;
	/* LOSE AGAIN */
	enum smmode {smm_input, smm_output, smm_io, smm_probe,
		     smm_synonym, smm_broadcast, smm_concatenated,
		     smm_two_way, smm_echo, smm_string_input,
		     smm_string_output};
	extern object Kinput;
	extern object Koutput;
	extern object Sstring_char;
	/* Ifdopen does the work amd is also called from PROCESS */
	object Ifdopen(fd, Ztype)
	int fd;
	object Ztype;
	{
	    Sobject result;		 /* s.b. object result */
	    FILE *f;
	    if (Ztype == Kinput)
	        f = fdopen(fd, "r");
	    else if (Ztype == Koutput)
		f = fdopen(fd, "w");
           else
	        FEerror("Fdopen: type must be :INPUT or :OUTPUT.", 0);
	    if (f == (FILE *)NULL)
	        Zerror("Fdopen failed.");
	    result = (Sobject)alloc_object(t_stream);
	    vs_push((object) result);
	    result->sm.sm_fp = f;
	    result->sm.sm_mode 
               = (short)((Ztype == Kinput) ? smm_input : smm_output);
	    result->sm.sm_object0 = Sstring_char;	/* elt type */
	    result->sm.sm_object1 = make_fixnum(fd);	/* ? OBJNULL ? */
	    result->sm.sm_int0 = 0;
	    result->sm.sm_int1 = 0;
	    setbuf(result->sm.sm_fp, alloc_contblock(BUFSIZ));
	    return(vs_pop);
	}
	object zfdopen(Zfildes, Ztype)
	object Zfildes, Ztype;
	{
	    check_arg(2);
	    return(Ifdopen(fix(Zfildes), Ztype));
	}
/*	function definition for FDOPEN	*/

static L9()
{	object *old_base=vs_base;
	object x;
	x=
	zfdopen(
	vs_base[0],
	vs_base[1]);
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=x;
}
/*	function definition for EXECLP	*/

static L10()
{register object *base=vs_base;
	register object *sup=base+VM2; VC2
	vs_check;
	{object V2;
	object V3;
	V2=(base[0]);
	vs_base=vs_base+1;
	vs_top[0]=Cnil;
	{object *p=vs_top;
	 for(;p>vs_base;p--)p[-1]=MMcons(p[-1],p[0]);}
	V3=(base[1]);
	vs_top=sup;
	{object V4;
	base[2]= (V2);
	vs_top=(vs_base=base+2)+1;
	Lpathname();
	vs_top=sup;
	V4= vs_base[0];
	base[4]= (V4);
	vs_top=(vs_base=base+4)+1;
	Lnamestring();
	vs_top=sup;
	base[3]= vs_base[0];
	vs_top=(vs_base=base+3)+1;
	(void) (*Lnk26)();
	vs_top=sup;
	base[2]= vs_base[0];
	base[6]= (V4);
	vs_top=(vs_base=base+6)+1;
	Lfile_namestring();
	vs_top=sup;
	base[5]= vs_base[0];
	vs_top=(vs_base=base+5)+1;
	(void) (*Lnk26)();
	vs_top=sup;
	V5= vs_base[0];
	{object V7;
	object V8= (V3);
	if(V8==Cnil){
	V6= Cnil;
	goto T14;}
	base[5]=V7=MMcons(Cnil,Cnil);
T15:;
	base[6]= (V8->c.c_car);
	vs_top=(vs_base=base+6)+1;
	(void) (*Lnk26)();
	vs_top=sup;
	(V7->c.c_car)= vs_base[0];
	if((V8=MMcdr(V8))==Cnil){
	V6= base[5];
	goto T14;}
	V7=MMcdr(V7)=MMcons(Cnil,Cnil);
	goto T15;}
T14:;
	base[4]= make_cons(V5,V6);
	base[5]= VV[1];
	vs_top=(vs_base=base+4)+2;
	(void) (*Lnk27)();
	vs_top=sup;
	base[3]= vs_base[0];
	vs_top=(vs_base=base+2)+2;
	(void) (*Lnk28)();
	return;}
	}
}
	extern char *malloc();
	extern void free();
	object zexecvp (Zname, Zargv)
	object Zname, Zargv;
	{
	    char **argv;
	    int nargs, i;
	    nargs = Zargv->v.v_fillp;
	    argv = (char **)malloc((nargs + 1) * sizeof(char *));
	    for(i = 0; i < nargs; i++)
	    {
		argv[i] = Zargv->v.v_self[i]->st.st_self;
	    }
	    argv[nargs] = (char *)0;
	    execvp(Zname->st.st_self, argv);
	    free(argv);
	    Zerror("Exec failed.");
	}
/*	function definition for INTERNAL-EXECVP	*/

static L11()
{	object *old_base=vs_base;
	object x;
	x=
	zexecvp(
	vs_base[0],
	vs_base[1]);
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=x;
}
	extern void check_type_stream();
	int stream_fd(Zstream)
	object Zstream;
	{
	    Sobject str;
	    check_type_stream(&Zstream);	/* make sure it is one */
	    str = (Sobject)Zstream;		/* s.b. unnecessary */
	    switch (str->sm.sm_mode)
	    {
	    case smm_input:
	    case smm_output:
	    case smm_io:
		return((int)fileno(str->sm.sm_fp));
	    default:
		FEerror("~S is not a simple input, output or io stream.",
		        1, Zstream);
	    }
	}
/*	function definition for STREAM-FD	*/

static L12()
{	object *old_base=vs_base;
	int x;
	x=
	stream_fd(
	vs_base[0]);
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=CMPmake_fixnum(x);
}
/*	C function defined by DEFCFUN	*/

object stream_type(Zstream) object Zstream;
{
object *vs=vs_top;
object *old_top=vs_top+0;
{
	Sobject str;				/* sigh */
	object result;
	check_type_stream(&Zstream);
	str = (Sobject)Zstream;
	switch(str->sm.sm_mode)
	{
	case smm_input:
result=VV[2];
	    break;
	case smm_output:
result=VV[3];
	    break;
	case smm_io:
result=VV[4];
	    break;
	case smm_probe:
result=VV[5];
	    break;
	case smm_synonym:
result=VV[6];
	    break;
	case smm_broadcast:
result=VV[7];
	    break;
	case smm_concatenated:
result=VV[8];
	    break;
	case smm_two_way:
result=VV[9];
	    break;
	case smm_echo:
result=VV[10];
	    break;
	case smm_string_input:
result=VV[11];
	    break;
	case smm_string_output:
result=VV[12];
	    break;
	default:
	    FEerror("Internal error: ~S claimed to be a stream.", 1, Zstream);
	}
	/* conditional to avoid unreached code warning after Creturn */
	if (result != Cnil) Creturn(result);
}
vs_top=vs;
}
/*	function definition for STREAM-TYPE	*/

static L13()
{	object *old_base=vs_base;
	object x;
	x=
	stream_type(
	vs_base[0]);
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=x;
}
/*	C function defined by DEFCFUN	*/

object stream_synonym(Zstream) object Zstream;
{
object *vs=vs_top;
object *old_top=vs_top+0;
{
   Sobject str;
   object result;
   check_type_stream(&Zstream);
   str = (Sobject)Zstream;
   if ((enum smmode)str->sm.sm_mode == smm_synonym)
   {
	result = str->sm.sm_object0;
	if (type_of(result) == t_symbol)
	    Creturn(result);
	FEerror("~S doesn't contain a variable.", 1, Zstream);
   }
   else
   {
	FEerror("~S is not a synonym stream", 1, Zstream);
   }

}
vs_top=vs;
}
/*	function definition for STREAM-SYNONYM	*/

static L14()
{	object *old_base=vs_base;
	object x;
	x=
	stream_synonym(
	vs_base[0]);
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=x;
}
   object unpack_stream(Zstream)
   object Zstream;
   {
	Sobject str;
	object result;
	check_type_stream(&Zstream);
	str = (Sobject)Zstream;
	switch(str->sm.sm_mode)
	{
	case smm_broadcast:
	    return(str->sm.sm_object0);		/* list of streams */
	case smm_two_way:
	case smm_echo:
	    vs_push(result = make_cons(str->sm.sm_object0, Cnil));
	    result->c.c_cdr = make_cons(str->sm.sm_object1, Cnil);
	    return(vs_pop);
	default:
	    return(Cnil);
	}
   }
/*	function definition for UNPACK-STREAM	*/

static L15()
{	object *old_base=vs_base;
	object x;
	x=
	unpack_stream(
	vs_base[0]);
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=x;
}
/*	function definition for DEREF-STREAM	*/

static L16()
{register object *base=vs_base;
	register object *sup=base+VM3; VC3
	vs_check;
	vs_top=sup;
TTL:;
	base[2]= base[0];
	vs_top=(vs_base=base+2)+1;
	L17(base);
	return;
}
/*	function definition for PROCESS	*/

static L18()
{register object *base=vs_base;
	register object *sup=base+VM4; VC4
	vs_check;
	{object V9;
	object V10;
	object V11;
	object V12;
	object V13;
	parse_key(vs_base+1,FALSE,FALSE,4,VV[22],VV[18],VV[19],VV[29]);
	V9=(base[0]);
	vs_top=sup;
	V10=(base[1]);
	if(base[6]==Cnil){
	V11= (VV[15]->s.s_dbind);
	}else{
	V11=(base[2]);}
	if(base[7]==Cnil){
	V12= (VV[16]->s.s_dbind);
	}else{
	V12=(base[3]);}
	if(base[8]==Cnil){
	V13= (VV[17]->s.s_dbind);
	}else{
	V13=(base[4]);}
	{object V14;
	base[9]= (V9);
	vs_top=(vs_base=base+9)+1;
	Lpathname();
	vs_top=sup;
	V14= vs_base[0];
	base[11]= (V14);
	vs_top=(vs_base=base+11)+1;
	Lnamestring();
	vs_top=sup;
	base[10]= vs_base[0];
	vs_top=(vs_base=base+10)+1;
	(void) (*Lnk26)();
	vs_top=sup;
	base[9]= vs_base[0];
	base[13]= (V14);
	vs_top=(vs_base=base+13)+1;
	Lfile_namestring();
	vs_top=sup;
	base[12]= vs_base[0];
	vs_top=(vs_base=base+12)+1;
	(void) (*Lnk26)();
	vs_top=sup;
	V15= vs_base[0];
	{object V17;
	object V18= (V10);
	if(V18==Cnil){
	V16= Cnil;
	goto T33;}
	base[12]=V17=MMcons(Cnil,Cnil);
T34:;
	base[13]= (V18->c.c_car);
	vs_top=(vs_base=base+13)+1;
	(void) (*Lnk26)();
	vs_top=sup;
	(V17->c.c_car)= vs_base[0];
	if((V18=MMcdr(V18))==Cnil){
	V16= base[12];
	goto T33;}
	V17=MMcdr(V17)=MMcons(Cnil,Cnil);
	goto T34;}
T33:;
	base[11]= make_cons(V15,V16);
	base[12]= VV[1];
	vs_top=(vs_base=base+11)+2;
	(void) (*Lnk27)();
	vs_top=sup;
	base[10]= vs_base[0];
	base[12]= (V11);
	base[13]= VV[18];
	vs_top=(vs_base=base+12)+2;
	L19(base);
	vs_top=sup;
	base[11]= vs_base[0];
	base[13]= (V12);
	base[14]= VV[19];
	vs_top=(vs_base=base+13)+2;
	L19(base);
	vs_top=sup;
	base[12]= vs_base[0];
	base[14]= (V13);
	base[15]= VV[19];
	vs_top=(vs_base=base+14)+2;
	L19(base);
	vs_top=sup;
	base[13]= vs_base[0];
	vs_top=(vs_base=base+9)+5;
	(void) (*Lnk30)();
	return;}
	}
}
#  include <sys/param.h>	/* for NOFILE */
#  include <fcntl.h>
#  ifdef sparc
#  include <vfork.h>           /* needed on SPARC */
#  endif
   object zprocess(Zname, Zargv, Zin, Zout, Zerr)
   object Zname, Zargv, Zin, Zout, Zerr;
   {
	char *name, **argv;
	int nargs;
	int child_pid;
	int read_child, write_child, read_child_error;	/* in parent */
	int child_input, child_output, child_error;	/* in child */
	int read_exec_error, write_exec_error;		/* parent <- child */
	int fd[2];
	int i;
	object result;
	/* Convert name and argv */
	name = Zname->st.st_self;
	nargs = Zargv->v.v_fillp;
	argv = (char **)malloc((nargs + 1) * sizeof(char *));
	for(i = 0; i < nargs; i++)
	    argv[i] = Zargv->v.v_self[i]->st.st_self;
	argv[nargs] = (char *)0;
	/* Set up child input.  If we make a pipe, we will
	 * later return a new stream in the parent.
	 */
	if (Zin == Cnil)
	{
	    if (pipe(fd) == -1) Zerror("Pipe failed.");
	    child_input = fd[0];
	    write_child = fd[1];
	}
	else child_input = fix(Zin);
	/* Set up child output.  If we make a pipe, we will
	 * later return a new stream in the parent.
	 */
	if (Zout == Cnil)
	{
	    if (pipe(fd) == -1) Zerror("Pipe failed.");
	    read_child = fd[0];
	    child_output = fd[1];
	}
	else child_output = fix(Zout);
	/* Set up child error output.  If we make a pipe, we will
	 * later return a new stream in the parent.
	 */
	if (Zerr == Cnil)
	{
	    if(pipe(fd) == -1) Zerror("Pipe failed.");
	    read_child_error = fd[0];
	    child_error = fd[1];
	}
	else child_error = fix(Zerr);
	/* Finally, we open a pipe that will be closed on exec -- if the
	 * exec succeeds.  If the exec fails, the child will write an error
	 * message which the parent can read.  This trick from R. Tobin.
	 */
	if (pipe(fd) == -1) Zerror("Exec error pipe failed.");
	read_exec_error = fd[0];
	write_exec_error = fd[1];
	fcntl(write_exec_error, F_SETFD, 1);	/* set close on exec bit */
#ifdef debug
	printf("child_input = %d, child_output = %d\n",
	       child_input, child_output);
	if (Zin == Cnil)
	   printf("write_child = %d\n", write_child);
	if (Zout == Cnil)
	   printf("read_child = %d\n", read_child);
	if (Zerr == Cnil)
	   printf("read_child_error = %d\n", read_child_error);
	if (child_error != 2)
	   printf("child_error = %d\n", child_error);
	printf("read_exec_error = %d, write = %d\n",
	       read_exec_error, write_exec_error);
	fflush(stdout);
#endif
	/* Fork */
	child_pid = vfork();
	if (child_pid == 0)
	{
	    /* Child.  Remember that we are somewhat limited in what
	     * we can do since we don't want to mess up the parent's
	     * address space.  No mallocs, etc.
	     */
	    /* Put files in place if needed */
	    if (child_input  != 0)
           {
		dup2(child_input, 0);
		close(child_input);
	    }
	    if (child_output != 1)
	    {
		dup2(child_output, 1);
		close(child_output);
	    }
	    if (child_error  != 2)
	    {
		dup2(child_error, 2);
		if (child_error != 1)		/* KCL makes it 1 */
		    close(child_error);
	    }
#ifdef undef
	    /* Close random files.  Note that this closes the parent
	     * ends of any pipes we might have made. 
	     */
	    for (i = 4; i < NOFILE; i++)
		if (i != write_exec_error) close(i);
#endif
	    /* Close parent ends if we made any */
	    /* N.B. This replaces the too-general close above. */
	    if (Zin == Cnil) close(write_child);
	    if (Zout == Cnil) close(read_child);
	    if (Zerr == Cnil) close(read_child_error);
	    /* Do the exec */
	    execvp(name, argv);
	    /* If we get here, the exec failed and we send a message */
	    dup2(write_exec_error, 2);
	    perror("Child exec");
	    _exit(-1);
	}
	/* Parent */
	/* release argv strings -- no exec here, so we don't need them */
	free(argv);
	/* Close the child ends if we made any */
	if (Zin == Cnil) close(child_input);
	if (Zout == Cnil) close(child_output);
	if (Zerr == Cnil) close(child_error);
	/* See if the exec failed.  If we close write_exec_error and it
	 * was also closed on exec, we will be unable to read from it.
	 */
	close(write_exec_error);
	{
	    char msg[257];
	    int nchars;
	    nchars = read(read_exec_error, msg, 256);
	    close(read_exec_error);
	    if (nchars != 0)
	    {
		if (nchars < 0) Zerror("Trouble reading exec error.");
		msg[nchars] = '\0';
		FEerror(msg, 0);
	    }
	}
	/* The final result is a list of 4 elements.  The first is
	 * the child pid, followed, if we made the corresponding pipe,
	 * by streams for reading and writing the child, respectively,
	 * and a stream for reading the child's error output.  When we
	 * did not make the pipe, the corresponding list entry is nil. 
	 */
	result = make_cons(Cnil, Cnil);
	vs_push(result);
	result->c.c_car = make_fixnum(child_pid);
	/* make stream to read child output */
	result = result->c.c_cdr = make_cons(Cnil, Cnil);
	if (Zout == Cnil) 
	   result->c.c_car = Ifdopen(read_child, Kinput);
	/* make stream to write child input */
	result = result->c.c_cdr = make_cons(Cnil, Cnil);
	if (Zin == Cnil)
	   result->c.c_car = Ifdopen(write_child, Koutput);
	/* make stream to read child's error output */
	result = result->c.c_cdr = make_cons(Cnil, Cnil);
	if (Zerr == Cnil)
	   result->c.c_car = Ifdopen(read_child_error, Koutput);
	return(vs_pop);
   }
/*	function definition for INTERNAL-PROCESS	*/

static L20()
{	object *old_base=vs_base;
	object x;
	x=
	zprocess(
	vs_base[0],
	vs_base[1],
	vs_base[2],
	vs_base[3],
	vs_base[4]);
	vs_top=(vs_base=old_base)+1;
	vs_base[0]=x;
}
/*	function definition for PROCESS-SEND	*/

static L21()
{register object *base=vs_base;
	register object *sup=base+VM5; VC5
	vs_check;
	{object V19;
	object V20;
	V19=(base[0]);
	vs_base=vs_base+1;
	vs_top[0]=Cnil;
	{object *p=vs_top;
	 for(;p>vs_base;p--)p[-1]=MMcons(p[-1],p[0]);}
	V20=(base[1]);
	vs_top=sup;
	base[2]= (V19);
	base[3]= VV[22];
	base[4]= (V20);
	base[5]= VV[18];
	base[6]= VV[20];
	vs_top=(vs_base=base+2)+5;
	(void) (*Lnk31)();
	vs_top=sup;
	V21= vs_base[0];
	base[2]= CMPcaddr(V21);
	vs_top=(vs_base=base+2)+1;
	return;
	}
}
/*	function definition for PROCESS-RECEIVE	*/

static L22()
{register object *base=vs_base;
	register object *sup=base+VM6; VC6
	vs_check;
	{object V22;
	object V23;
	V22=(base[0]);
	vs_base=vs_base+1;
	vs_top[0]=Cnil;
	{object *p=vs_top;
	 for(;p>vs_base;p--)p[-1]=MMcons(p[-1],p[0]);}
	V23=(base[1]);
	vs_top=sup;
	base[2]= (V22);
	base[3]= VV[22];
	base[4]= (V23);
	base[5]= VV[19];
	base[6]= VV[20];
	vs_top=(vs_base=base+2)+5;
	(void) (*Lnk31)();
	vs_top=sup;
	V24= vs_base[0];
	base[2]= CMPcadr(V24);
	vs_top=(vs_base=base+2)+1;
	return;
	}
}
/*	function definition for BREAK-ARGS	*/

static L23()
{register object *base=vs_base;
	register object *sup=base+VM7; VC7
	vs_check;
	vs_top=sup;
TTL:;
	{register object V25;
	register object V26;
	base[1]= small_fixnum(0);
	V25= Cnil;
	V26= Cnil;
T60:;
T64:;
	vs_base=vs_top;
	L26(base);
	vs_top=sup;
	if((vs_base[0])==Cnil){
	goto T66;}
	goto T62;
T66:;
	vs_base=vs_top;
	L24(base);
	vs_top=sup;
	V27= vs_base[0];
	if(!(char_code(V27)==char_code(VV[23]))){
	goto T70;}
	vs_base=vs_top;
	L25(base);
	vs_top=sup;
	goto T65;
T70:;
	goto T62;
T65:;
	goto T64;
T62:;
	vs_base=vs_top;
	L26(base);
	vs_top=sup;
	if((vs_base[0])==Cnil){
	goto T74;}
	base[2]= nreverse((V25));
	vs_top=(vs_base=base+2)+1;
	return;
T74:;
	V26= Cnil;
	vs_base=vs_top;
	L24(base);
	vs_top=sup;
	V28= vs_base[0];
	if(!(char_code(V28)==char_code(VV[24]))){
	goto T80;}
	vs_base=vs_top;
	L25(base);
	vs_top=sup;
T85:;
	vs_base=vs_top;
	L26(base);
	vs_top=sup;
	if((vs_base[0])!=Cnil){
	goto T87;}
	vs_base=vs_top;
	L24(base);
	vs_top=sup;
	V29= vs_base[0];
	if(!(char_code(V29)==char_code(VV[24]))){
	goto T88;}
T87:;
	base[2]= nreverse((V26));
	base[3]= VV[0];
	vs_top=(vs_base=base+2)+2;
	(void) (*Lnk27)();
	vs_top=sup;
	V30= vs_base[0];
	V25= make_cons(V30,(V25));
	vs_base=vs_top;
	L25(base);
	vs_top=sup;
	goto T61;
T88:;
	vs_base=vs_top;
	L24(base);
	vs_top=sup;
	V31= vs_base[0];
	V26= make_cons(V31,(V26));
	vs_base=vs_top;
	L25(base);
	vs_top=sup;
	goto T85;
T80:;
T104:;
	vs_base=vs_top;
	L26(base);
	vs_top=sup;
	if((vs_base[0])!=Cnil){
	goto T106;}
	vs_base=vs_top;
	L24(base);
	vs_top=sup;
	V32= vs_base[0];
	if(!(char_code(V32)==char_code(VV[23]))){
	goto T107;}
T106:;
	base[2]= nreverse((V26));
	base[3]= VV[0];
	vs_top=(vs_base=base+2)+2;
	(void) (*Lnk27)();
	vs_top=sup;
	V33= vs_base[0];
	V25= make_cons(V33,(V25));
	vs_base=vs_top;
	L25(base);
	vs_top=sup;
	goto T61;
T107:;
	vs_base=vs_top;
	L24(base);
	vs_top=sup;
	V34= vs_base[0];
	V26= make_cons(V34,(V26));
	vs_base=vs_top;
	L25(base);
	vs_top=sup;
	goto T104;
T61:;
	goto T60;}
}
/*	local function DONE	*/

static L26(base0)
register object *base0;
{	register object *base=vs_base;
	register object *sup=base+VM8; VC8
	vs_check;
	vs_top=sup;
TTL:;
	V35 = CMPmake_fixnum(length(base0[0]));
	base[0]= (number_compare(base0[1],V35)>=0?Ct:Cnil);
	vs_top=(vs_base=base+0)+1;
	return;
}
/*	local function NEXT	*/

static L25(base0)
register object *base0;
{	register object *base=vs_base;
	register object *sup=base+VM9; VC9
	vs_check;
	vs_top=sup;
TTL:;
	base0[1]= number_plus(base0[1],small_fixnum(1));
	base[0]= base0[1];
	vs_top=(vs_base=base+0)+1;
	return;
}
/*	local function CURRENT	*/

static L24(base0)
register object *base0;
{	register object *base=vs_base;
	register object *sup=base+VM10; VC10
	vs_check;
	vs_top=sup;
TTL:;
	base[0]= code_char((base0[0])->ust.ust_self[fix(base0[1])]);
	vs_top=(vs_base=base+0)+1;
	return;
}
/*	local function CHECK-STREAM-ARG	*/

static L19(base0)
register object *base0;
{	register object *base=vs_base;
	register object *sup=base+VM11; VC11
	vs_check;
	{register object V36;
	object V37;
	V36=(base[0]);
	V37=(base[1]);
	vs_top=sup;
TTL:;
	if(!(type_of((V36))==t_fixnum)){
	goto T125;}
	base[2]= (V36);
	vs_top=(vs_base=base+2)+1;
	return;
T125:;
	if(!(((V36))==(VV[20]))){
	goto T128;}
	base[2]= Cnil;
	vs_top=(vs_base=base+2)+1;
	return;
T128:;
	if(!(((V36))==(Ct))){
	goto T131;}
	base[2]= Cnil;
	vs_top=(vs_base=base+2)+1;
	return;
T131:;
	base[2]= (V36);
	vs_top=(vs_base=base+2)+1;
	Lstreamp();
	vs_top=sup;
	if((vs_base[0])==Cnil){
	goto T134;}
	base[3]= (V36);
	base[4]= (V37);
	vs_top=(vs_base=base+3)+2;
	(void) (*Lnk32)();
	vs_top=sup;
	base[2]= vs_base[0];
	vs_top=(vs_base=base+2)+1;
	(void) (*Lnk33)();
	return;
T134:;
	base[2]= VV[21];
	base[3]= (V37);
	base[4]= (V36);
	vs_top=(vs_base=base+2)+3;
	Lerror();
	return;
	}
}
/*	local function DEREF	*/

static L17(base0)
register object *base0;
{	register object *base=vs_base;
	register object *sup=base+VM12; VC12
	vs_check;
	{register object V38;
	V38=(base[0]);
	vs_top=sup;
TTL:;
	{object V39= base0[1];
	if((V39!= VV[18]))goto T143;
	base[1]= (V38);
	vs_top=(vs_base=base+1)+1;
	(void) (*Lnk34)();
	vs_top=sup;
	V41= vs_base[0];
	{object V40= V41;
	if((V40!= VV[2]))goto T146;
	base[1]= (V38);
	vs_top=(vs_base=base+1)+1;
	return;
T146:;
	if((V40!= VV[4]))goto T147;
	base[1]= (V38);
	vs_top=(vs_base=base+1)+1;
	return;
T147:;
	if((V40!= VV[6]))goto T148;
	base[2]= (V38);
	vs_top=(vs_base=base+2)+1;
	(void) (*Lnk35)();
	vs_top=sup;
	base[1]= vs_base[0];
	vs_top=(vs_base=base+1)+1;
	Lsymbol_value();
	vs_top=sup;
	V38= vs_base[0];
	goto TTL;
	return;
T148:;
	if((V40!= VV[9]))goto T153;
	base[1]= (V38);
	vs_top=(vs_base=base+1)+1;
	(void) (*Lnk36)();
	vs_top=sup;
	V42= vs_base[0];
	V38= CMPcar(V42);
	goto TTL;
	return;
T153:;
	base[1]= VV[13];
	base[2]= base0[0];
	vs_top=(vs_base=base+1)+2;
	Lerror();
	return;}
T143:;
	if((V39!= VV[19]))goto T160;
	base[1]= (V38);
	vs_top=(vs_base=base+1)+1;
	(void) (*Lnk34)();
	vs_top=sup;
	V44= vs_base[0];
	{object V43= V44;
	if((V43!= VV[3]))goto T163;
	base[1]= (V38);
	vs_top=(vs_base=base+1)+1;
	return;
T163:;
	if((V43!= VV[4]))goto T164;
	base[1]= (V38);
	vs_top=(vs_base=base+1)+1;
	return;
T164:;
	if((V43!= VV[6]))goto T165;
	base[2]= (V38);
	vs_top=(vs_base=base+2)+1;
	(void) (*Lnk35)();
	vs_top=sup;
	base[1]= vs_base[0];
	vs_top=(vs_base=base+1)+1;
	Lsymbol_value();
	vs_top=sup;
	V38= vs_base[0];
	goto TTL;
	return;
T165:;
	if((V43!= VV[9]))goto T170;
	base[1]= (V38);
	vs_top=(vs_base=base+1)+1;
	(void) (*Lnk36)();
	vs_top=sup;
	V45= vs_base[0];
	V38= CMPcadr(V45);
	goto TTL;
	return;
T170:;
	base[1]= VV[14];
	base[2]= base0[0];
	vs_top=(vs_base=base+1)+2;
	Lerror();
	return;}
T160:;
	FEerror("The ECASE key value ~s is illegal.",1,V39);}
	}
}
static LnkT36(){ call_or_link(VV[36],&Lnk36);} /* UNPACK-STREAM */
static LnkT35(){ call_or_link(VV[35],&Lnk35);} /* STREAM-SYNONYM */
static LnkT34(){ call_or_link(VV[34],&Lnk34);} /* STREAM-TYPE */
static LnkT33(){ call_or_link(VV[33],&Lnk33);} /* STREAM-FD */
static LnkT32(){ call_or_link(VV[32],&Lnk32);} /* DEREF-STREAM */
static LnkT31(){ call_or_link(VV[31],&Lnk31);} /* PROCESS */
static LnkT30(){ call_or_link(VV[30],&Lnk30);} /* INTERNAL-PROCESS */
static LnkT28(){ call_or_link(VV[28],&Lnk28);} /* INTERNAL-EXECVP */
static LnkT27(){ call_or_link(VV[27],&Lnk27);} /* COERCE */
static LnkT26(){ call_or_link(VV[26],&Lnk26);} /* C-STRING */
static LnkT25(){ call_or_link(VV[25],&Lnk25);} /* CONCATENATE */
